"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ParameterStoreConfigModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterStoreConfigModule = void 0;
const common_1 = require("@nestjs/common");
const parameter_store_service_1 = require("../aws/parameter-store/parameter-store.service");
const config_service_1 = require("./config.service");
const constant_1 = require("../../shared/constant/config/constant");
const config_parameters_provider_1 = require("../../shared/provider/config/config-parameters.provider");
const properties_provider_1 = require("../../shared/provider/config/properties.provider");
const ssm_client_provider_1 = require("../../shared/provider/config/ssm-client.provider");
let ParameterStoreConfigModule = ParameterStoreConfigModule_1 = class ParameterStoreConfigModule {
    /**
     * Registers the given options for dynamic module configuration.
     *
     * @param {IParameterStoreConfigProperties} options - The configuration options.
     * @return {DynamicModule} - The dynamic module configuration.
     */
    static register(options) {
        const propertiesProvider = (0, properties_provider_1.default)(options);
        return {
            exports: [config_service_1.ParameterStoreConfigService, constant_1.PARAMETER_STORE_CONFIG_PARAMETERS],
            module: ParameterStoreConfigModule_1,
            providers: [propertiesProvider, config_parameters_provider_1.default, ssm_client_provider_1.default, config_service_1.ParameterStoreConfigService, parameter_store_service_1.default],
        };
    }
    /**
     * Registers an asynchronous module in the application.
     *
     * @param {IParameterStoreConfigAsyncModuleProperties} properties - The properties for the async module.
     * @return {DynamicModule} - The registered dynamic module.
     */
    static registerAsync(properties) {
        const providers = this.createAsyncProviders(properties);
        return {
            exports: [config_service_1.ParameterStoreConfigService, constant_1.PARAMETER_STORE_CONFIG_PARAMETERS],
            imports: properties.imports || [],
            module: ParameterStoreConfigModule_1,
            providers,
        };
    }
    /**
     * Creates an async options provider for the given `properties` object.
     *
     * @param {IParameterStoreConfigAsyncModuleProperties} properties - The properties object used to configure the async options provider.
     * @returns {Provider} - The created async options provider.
     * @private
     */
    static createAsyncOptionsProvider(properties) {
        if (properties.useFactory) {
            return {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
                inject: properties.inject || [],
                provide: constant_1.PARAMETER_STORE_CONFIG_PROPERTIES,
                useFactory: properties.useFactory,
            };
        }
        const inject = properties.useExisting || properties.useClass;
        return {
            inject: inject ? [inject] : [],
            provide: constant_1.PARAMETER_STORE_CONFIG_PROPERTIES,
            useFactory: async (optionsFactory) => {
                return optionsFactory.createOptions();
            },
        };
    }
    /**
     * Creates an array of Providers for asynchronous module configuration using the given properties.
     *
     * @param {IParameterStoreConfigAsyncModuleProperties} properties - The properties for configuring the module asynchronously.
     *
     * @returns {Array<Provider>} An array of Providers for the module configuration.
     *
     * @private
     */
    static createAsyncProviders(properties) {
        const optionsProvider = this.createAsyncOptionsProvider(properties);
        const requestProviders = [optionsProvider, config_parameters_provider_1.default, ssm_client_provider_1.default, config_service_1.ParameterStoreConfigService, parameter_store_service_1.default];
        if (properties.useExisting || properties.useFactory || !properties.useClass) {
            return requestProviders;
        }
        return [
            ...requestProviders,
            {
                provide: properties.useClass,
                useClass: properties.useClass,
            },
        ];
    }
};
exports.ParameterStoreConfigModule = ParameterStoreConfigModule;
exports.ParameterStoreConfigModule = ParameterStoreConfigModule = ParameterStoreConfigModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
    // eslint-disable-next-line import/prefer-default-export
], ParameterStoreConfigModule);
//# sourceMappingURL=config.module.js.map