import type { Parameter } from "@aws-sdk/client-ssm";
export declare class ParameterStoreConfigService {
    private readonly parameters;
    constructor(parameters: Array<Parameter>);
    /**
     * Retrieves the value of a parameter with the specified name.
     *
     * @param {string} name - The name of the parameter to retrieve.
     * @return {null|string} - The value of the parameter if found, or null if not found.
     */
    get(name: string): null | string;
}
