"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parameter_store_service_1 = require("../../../modules/aws/parameter-store/parameter-store.service");
const constant_1 = require("../../constant/config/constant");
const ParameterStoreConfigParametersProvider = {
    inject: [constant_1.PARAMETER_STORE_CONFIG_PROPERTIES, parameter_store_service_1.default],
    provide: constant_1.PARAMETER_STORE_CONFIG_PARAMETERS,
    useFactory: async (properties, parameterStoreService) => {
        let path;
        if (properties.basePath) {
            path = properties.basePath;
        }
        else if (properties.application) {
            path = `/${properties.application}`;
            if (properties.environment) {
                path = `${path}/${properties.environment}`;
            }
        }
        else {
            path = "/";
        }
        return parameterStoreService.getParametersByPath(path, properties.decryptParameters ?? false, properties.recursiveLoading ?? false, properties.verbose ?? false);
    },
};
exports.default = ParameterStoreConfigParametersProvider;
//# sourceMappingURL=config-parameters.provider.js.map